//******************************************************************************
//  Copyright (c) 2005-2009 by Jan Van hijfte
//
//  See the included file COPYING.TXT for details about the copyright.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//******************************************************************************


#ifndef QWORKSPACE_HOOK_H
#define QWORKSPACE_HOOK_H

#include <QtGui>

#include "qwidget_hook.h"

class QWorkspace_hook : public QWidget_hook {
  Q_OBJECT
  public:
    QWorkspace_hook(QObject *handle) : QWidget_hook(handle) {
      windowActivated_event.func = NULL;
    }
    void hook_windowActivated(QHook &hook) { 
      if ( !windowActivated_event.func )
        connect(handle, SIGNAL(windowActivated(QWidget*)), this, SLOT(windowActivated_hook(QWidget*)));
      windowActivated_event = hook;
      if ( !hook.func )
        disconnect(handle, SIGNAL(windowActivated(QWidget*)), this, SLOT(windowActivated_hook(QWidget*)));
    }

  private slots:
    void windowActivated_hook(QWidget* w) {
      if ( windowActivated_event.func ) {
        typedef void (*func_type)(void *data, QWidgetH w);
	(*(func_type)windowActivated_event.func)(windowActivated_event.data, (QWidgetH)w);
      }
    }
  private:
    QHook windowActivated_event;
};


#endif
